diff --git a/game/client/src/main/java/org/useless/dragonfly/models/block/mojang/StaticBlockModelMojang.java b/game/client/src/main/java/org/useless/dragonfly/models/block/mojang/StaticBlockModelMojang.java
index 0b7b5cb8e..78971b1c4 100644
--- a/game/client/src/main/java/org/useless/dragonfly/models/block/mojang/StaticBlockModelMojang.java
+++ b/game/client/src/main/java/org/useless/dragonfly/models/block/mojang/StaticBlockModelMojang.java
@@ -104,17 +104,17 @@ public class StaticBlockModelMojang implements StaticBlockModel {
             for (int face = 0; face < element.faces; face++) {
                 Direction cullDir = element.cullfaces[face];
                 if (cullFaces && cullDir != null) {
-                    cullDir = Direction.rotateZ(Direction.rotateY(Direction.rotateX(cullDir, rotX), rotY), rotZ);
-                    if ((cullCache & (1 << cullDir.getId())) != 0) {
+                    cullDir = cullDir.rotateX(rotX).rotateY(rotY).rotateZ(rotZ);
+                    if ((cullCache & (1 << cullDir.id)) != 0) {
                         continue;
                     }
                     if (sourceModel.cullSide(worldSource, blockPos, cullDir)) {
-                        cullCache |= (byte) (1 << cullDir.getId());
+                        cullCache |= (byte) (1 << cullDir.id);
                         continue;
                     }
                 }
                 final IconCoordinate coordinate = overrideTexture == null ? element.textures[face] : overrideTexture;
-                Direction direction = Direction.rotateZ(Direction.rotateY(Direction.rotateX(element.directions[face], rotX), rotY), rotZ);
+                Direction direction = element.directions[face].rotateX(rotX).rotateY(rotY).rotateZ(rotZ);
 
                 final float minBrightness = element.lightEmission / 15f;
 
@@ -252,9 +252,9 @@ public class StaticBlockModelMojang implements StaticBlockModel {
                     b = 1;
                 }
 
-                final int dirX = element.flip ? -direction.getOffsetX() : direction.getOffsetX();
-                final int dirY = element.flip ? -direction.getOffsetY() : direction.getOffsetY();
-                final int dirZ = element.flip ? -direction.getOffsetZ() : direction.getOffsetZ();
+                final int dirX = element.flip ? -direction.offsetX() : direction.offsetX();
+                final int dirY = element.flip ? -direction.offsetY() : direction.offsetY();
+                final int dirZ = element.flip ? -direction.offsetZ() : direction.offsetZ();
 
                 final byte lightIndexTopLeft;
                 final byte lightIndexBottomLeft;
@@ -489,7 +489,7 @@ public class StaticBlockModelMojang implements StaticBlockModel {
         float v = uvs.y() - 0.5f;
         rotX = (rotX & 0b11);
         while (rotX > 0) {
-            if (dir.getAxis() == Axis.X) {
+            if (dir.axis() == Axis.X) {
                 if (dir == Direction.WEST) {
                     float _u = u;
                     u = -v;
@@ -505,13 +505,13 @@ public class StaticBlockModelMojang implements StaticBlockModel {
                     u = -u;
                 }
             }
-            dir = Direction.rotateX(dir, 1);
+            dir = dir.rotateX(1);
             rotX--;
         }
 
         rotY = (rotY & 0b11);
         while (rotY > 0) {
-            if (dir.getAxis() == Axis.Y) {
+            if (dir.axis() == Axis.Y) {
                 if (dir == Direction.DOWN) {
                     float _v = v;
                     v = u;
@@ -522,13 +522,13 @@ public class StaticBlockModelMojang implements StaticBlockModel {
                     v = -_u;
                 }
             }
-            dir = Direction.rotateY(dir, 1);
+            dir = dir.rotateY(1);
             rotY--;
         }
 
         rotZ = (rotZ & 0b11);
         while (rotZ > 0) {
-            if (dir.getAxis() == Axis.Z) {
+            if (dir.axis() == Axis.Z) {
                 if (dir == Direction.NORTH) {
                     float _u = u;
                     u = -v;
@@ -545,7 +545,7 @@ public class StaticBlockModelMojang implements StaticBlockModel {
                     u = _v;
                 }
             }
-            dir = Direction.rotateZ(dir, 1);
+            dir = dir.rotateZ(1);
             rotZ--;
         }
 
@@ -560,12 +560,12 @@ public class StaticBlockModelMojang implements StaticBlockModel {
 
     @Override
     public @Nullable IconCoordinate getParticle(@NotNull Side side) {
-        return this.compiled.textures.get("#particle_" + side.getDirection().name().toLowerCase(Locale.ROOT));
+        return this.compiled.textures.get("#particle_" + side.direction().name().toLowerCase(Locale.ROOT));
     }
 
     @Override
     public int particleColorIndex(@NotNull Side side) {
-        return this.compiled.particleIndices[side.getId()];
+        return this.compiled.particleIndices[side.id];
     }
 
     @Override
diff --git a/game/client/src/main/java/org/useless/dragonfly/models/entity/mojang/StaticEntityModelMojang.java b/game/client/src/main/java/org/useless/dragonfly/models/entity/mojang/StaticEntityModelMojang.java
index 70c8bc788..59187d286 100644
--- a/game/client/src/main/java/org/useless/dragonfly/models/entity/mojang/StaticEntityModelMojang.java
+++ b/game/client/src/main/java/org/useless/dragonfly/models/entity/mojang/StaticEntityModelMojang.java
@@ -174,7 +174,7 @@ public class StaticEntityModelMojang implements StaticEntityModel {
             final double maxZ = minZ + cube.size[2] + (cube.inflate + bone.inflate + this.inflation) * 2;
 
             // Top
-            Face face = cube.faces[Direction.UP.getId()];
+            Face face = cube.faces[Direction.UP.id];
             if (face != null) {
                 final double uMin = (face.uv[0]) / this.data.textureWidth;
                 final double uMax = (face.uv[0] + face.uv_size[0]) / this.data.textureWidth;
@@ -200,7 +200,7 @@ public class StaticEntityModelMojang implements StaticEntityModel {
             }
 
             // Bottom
-            face = cube.faces[Direction.DOWN.getId()];
+            face = cube.faces[Direction.DOWN.id];
             if (face != null) {
                 final double uMin = (face.uv[0]) / this.data.textureWidth;
                 final double uMax = (face.uv[0] + face.uv_size[0]) / this.data.textureWidth;
@@ -225,7 +225,7 @@ public class StaticEntityModelMojang implements StaticEntityModel {
             }
 
             // Front
-            face = cube.faces[Direction.NORTH.getId()];
+            face = cube.faces[Direction.NORTH.id];
             if (face != null) {
                 final double uMin = (face.uv[0]) / this.data.textureWidth;
                 final double uMax = (face.uv[0] + face.uv_size[0]) / this.data.textureWidth;
@@ -250,7 +250,7 @@ public class StaticEntityModelMojang implements StaticEntityModel {
             }
 
             // Back
-            face = cube.faces[Direction.SOUTH.getId()];
+            face = cube.faces[Direction.SOUTH.id];
             if (face != null) {
                 final double uMin = (face.uv[0]) / this.data.textureWidth;
                 final double uMax = (face.uv[0] + face.uv_size[0]) / this.data.textureWidth;
@@ -275,7 +275,7 @@ public class StaticEntityModelMojang implements StaticEntityModel {
             }
 
             // Right
-            face = cube.faces[Direction.WEST.getId()];
+            face = cube.faces[Direction.WEST.id];
             if (face != null) {
                 final double uMin = (face.uv[0]) / this.data.textureWidth;
                 final double uMax = (face.uv[0] + face.uv_size[0]) / this.data.textureWidth;
@@ -300,7 +300,7 @@ public class StaticEntityModelMojang implements StaticEntityModel {
             }
 
             // Left
-            face = cube.faces[Direction.EAST.getId()];
+            face = cube.faces[Direction.EAST.id];
             if (face != null) {
                 final double uMin = (face.uv[0]) / this.data.textureWidth;
                 final double uMax = (face.uv[0] + face.uv_size[0]) / this.data.textureWidth;
diff --git a/game/core/src/main/java/net/minecraft/core/block/Block.java b/game/core/src/main/java/net/minecraft/core/block/Block.java
index 645222364..d983689be 100644
--- a/game/core/src/main/java/net/minecraft/core/block/Block.java
+++ b/game/core/src/main/java/net/minecraft/core/block/Block.java
@@ -296,26 +296,11 @@ public final class Block<T extends BlockLogic>
         return this.logic.isCubeShaped();
     }
 
-    @Override
-    public boolean canPlaceOnSurface() {
-        return this.logic.canPlaceOnSurface();
-    }
-
-    @Override
-    public boolean canPlaceOnSurfaceOnCondition(final @NotNull World world, final @NotNull TilePosc tilePos) {
-        return this.logic.canPlaceOnSurfaceOnCondition(world, tilePos);
-    }
-
     @Override
     public boolean renderAsNormalBlockOnCondition(final @NotNull WorldSource source, final @NotNull TilePosc tilePos) {
         return this.logic.renderAsNormalBlockOnCondition(source, tilePos);
     }
-
-    @Override
-    public boolean canPlaceOnSurface(final @NotNull World world, final @NotNull TilePosc tilePos) {
-        return this.logic.canPlaceOnSurface(world, tilePos);
-    }
-
+    
     @Override
     public @NotNull ItemStack @Nullable [] getBreakResult(final @NotNull World world, final @NotNull EnumDropCause dropCause, final @NotNull TilePosc tilePos, final int data, final @Nullable TileEntity tileEntity) {
         return this.logic.getBreakResult(world, dropCause, tilePos, data, tileEntity);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockInterface.java b/game/core/src/main/java/net/minecraft/core/block/BlockInterface.java
index d4d212a36..1025fba80 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockInterface.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockInterface.java
@@ -39,17 +39,6 @@ interface BlockInterface {
 
     boolean isCubeShaped();
 
-    @Deprecated
-    boolean canPlaceOnSurface();
-
-    @Deprecated
-    boolean canPlaceOnSurfaceOnCondition(final @NotNull World world, final @NotNull TilePosc tilePos);
-
-    @Deprecated
-    default boolean canPlaceOnSurfaceOnCondition(final @NotNull World world, final int x, final int y, final int z) {
-        return this.canPlaceOnSurfaceOnCondition(world, new TilePos(x, y, z));
-    }
-
     boolean renderAsNormalBlockOnCondition(final @NotNull WorldSource source, final @NotNull TilePosc tilePos);
 
     @Deprecated
@@ -57,14 +46,6 @@ interface BlockInterface {
         return this.renderAsNormalBlockOnCondition(world, new TilePos(x, y, z));
     }
 
-    @Deprecated
-    boolean canPlaceOnSurface(final @NotNull World world, final @NotNull TilePosc tilePos);
-
-    @Deprecated
-    default boolean canPlaceOnSurfaceOfBlock(final @NotNull World world, final int x, final int y, final int z) {
-        return this.canPlaceOnSurface(world, new TilePos(x, y, z));
-    }
-
     /**
      * Make sure if this gets overridden in a block that {@link net.minecraft.core.block.Block#getBreakResult(World, EnumDropCause, int, TileEntity)} also has a valid method since {@link EntityFallingBlock EntityFallingBlock} uses it!
      */
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogic.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogic.java
index 3d75f6085..bde66452d 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogic.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogic.java
@@ -78,26 +78,11 @@ public class BlockLogic implements BlockInterface, IItemConvertible {
         return true;
     }
 
-    @Override
-    public boolean canPlaceOnSurface() {
-        return this.isCubeShaped();
-    }
-
-    @Override
-    public boolean canPlaceOnSurfaceOnCondition(final @NotNull World world, final @NotNull TilePosc tilePos) {
-        return this.canPlaceOnSurface();
-    }
-
     @Override
     public boolean renderAsNormalBlockOnCondition(final @NotNull WorldSource source, final @NotNull TilePosc tilePos) {
         return this.isCubeShaped();
     }
 
-    @Override
-    public boolean canPlaceOnSurface(final @NotNull World world, final @NotNull TilePosc tilePos) {
-        return this.canPlaceOnSurface();
-    }
-
     @Override
     public @NotNull ItemStack @Nullable [] getBreakResult(final @NotNull World world, final @NotNull EnumDropCause dropCause, final @NotNull TilePosc tilePos, final int data, final @Nullable TileEntity tileEntity) {
         return this.getBreakResult(world, dropCause, data, tileEntity);
@@ -410,6 +395,10 @@ public class BlockLogic implements BlockInterface, IItemConvertible {
         }
     }
 
+
+    /**
+     * Note: tilePos is not necessarily a real position where the block exist, keep that in mind when overriding!
+     */
     @Override
     public void dropWithCause(final @NotNull World world, final @NotNull EnumDropCause dropCause, final @NotNull TilePosc tilePos, final int data, final @Nullable TileEntity tileEntity, final @Nullable Player player) {
         if (world.isClientSide)
@@ -443,7 +432,7 @@ public class BlockLogic implements BlockInterface, IItemConvertible {
     public @NotNull ISupport getSupport(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side) {
         return FullSupport.INSTANCE;
     }
-
+    
     @Override
     public boolean canStay(final @NotNull World world, final @NotNull TilePosc tilePos) {
         return true;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicActivator.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicActivator.java
index 4aa798ee7..20dea1629 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicActivator.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicActivator.java
@@ -50,9 +50,9 @@ public class BlockLogicActivator
         if (!activator.locked(activator.stackSelector)) {
             final @Nullable ItemStack itemStack = activator.getNextStack();
 
-            final double px = direction.getOffsetX() * 0.6D + 0.5D;
-            final double py = direction.getOffsetY() * 0.6D + 0.5D;
-            final double pz = direction.getOffsetZ() * 0.6D + 0.5D;
+            final double px = direction.offsetX() * 0.6D + 0.5D;
+            final double py = direction.offsetY() * 0.6D + 0.5D;
+            final double pz = direction.offsetZ() * 0.6D + 0.5D;
 
             if (itemStack == null) {
                 final @Nullable Block<?> block = world.getBlockType(tilePos.add(direction, new TilePos()));
@@ -67,7 +67,7 @@ public class BlockLogicActivator
                 item.onUseByActivator(itemStack, world, activator, random, tilePos, direction, px, py, pz);
                 activator.nullDeadItems();
                 world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, tilePos.x(), tilePos.y(), tilePos.z(), "tile.activator.use", 1, 1);
-                world.playBlockEvent(tilePos, LevelListener.EVENT_DISPENSER_PARTICLES, direction.getId());
+                world.playBlockEvent(tilePos, LevelListener.EVENT_DISPENSER_PARTICLES, direction.id);
             }
         } else {
             activator.shiftSelector();
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicAir.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicAir.java
index bc9aa1af8..93f4ffb1d 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicAir.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicAir.java
@@ -32,26 +32,11 @@ public class BlockLogicAir
         return false;
     }
 
-    @Override
-    public boolean canPlaceOnSurface() {
-        return false;
-    }
-
-    @Override
-    public boolean canPlaceOnSurfaceOnCondition(final @NotNull World world, final @NotNull TilePosc tilePos) {
-        return false;
-    }
-
     @Override
     public boolean renderAsNormalBlockOnCondition(final @NotNull WorldSource source, final @NotNull TilePosc tilePos) {
         return false;
     }
 
-    @Override
-    public boolean canPlaceOnSurface(final @NotNull World world, final @NotNull TilePosc tilePos) {
-        return false;
-    }
-
     @Override
     public @NotNull ItemStack @Nullable [] getBreakResult(final @NotNull World world, final @NotNull EnumDropCause dropCause, final int data, final @Nullable TileEntity tileEntity) {
         return null;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicAxisAligned.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicAxisAligned.java
index 5305375e2..1f78a5629 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicAxisAligned.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicAxisAligned.java
@@ -19,14 +19,14 @@ public class BlockLogicAxisAligned
 
     @Override
     public void onPlacedByMob(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final @NotNull Mob mob, final double xHit, final double yHit) {
-        final @NotNull Axis axis = mob.getPlacementDirection(side, PlacementMode.SIDE).getAxis();
+        final @NotNull Axis axis = mob.getPlacementDirection(side, PlacementMode.SIDE).axis();
 
         world.setBlockDataNotify(tilePos, axisToMeta(axis));
     }
 
     @Override
     public void onPlacedOnSide(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final double xHit, final double yHit) {
-        final @NotNull Axis axis = side.getAxis();
+        final @NotNull Axis axis = side.axis();
 
         world.setBlockDataNotify(tilePos, axisToMeta(axis));
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBasket.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBasket.java
index 2c3d16b1c..0dfcb1aae 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBasket.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBasket.java
@@ -92,18 +92,13 @@ public class BlockLogicBasket extends BlockLogic {
 
     @Override
     public void onPlacedByWorld(final @NotNull World world, final @NotNull TilePosc tilePos) {
-        TilePos queryPos = new TilePos();
-        for (final @NotNull Direction d : Direction.directions) {
-            world.notifyBlocksOfNeighborChange(tilePos.add(d, queryPos), this.block);
-        }
+        // world.notifyBlocksInRadiusOfNeighborChange(2, tilePos, this.block);
     }
 
     @Override
     public void onRemoved(final @NotNull World world, final @NotNull TilePosc tilePos, final int data) {
-        TilePos queryPos = new TilePos();
-        for (final @NotNull Direction d : Direction.directions) {
-            world.notifyBlocksOfNeighborChange(tilePos.add(d, queryPos), this.block);
-        }
+        // // let tile entity handles ranged update
+        // world.notifyBlocksInRadiusOfNeighborChange(2, tilePos, this.block);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBed.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBed.java
index e8f021467..c2f57246a 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBed.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBed.java
@@ -4,7 +4,9 @@ import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.block.material.Materials;
+import net.minecraft.core.block.support.FullSupport;
 import net.minecraft.core.block.support.ISupport;
+import net.minecraft.core.block.support.ISupportable;
 import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
@@ -12,7 +14,6 @@ import net.minecraft.core.enums.EnumSleepStatus;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.PackedField;
-import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
@@ -23,7 +24,8 @@ import org.jetbrains.annotations.Nullable;
 import java.util.Objects;
 
 public class BlockLogicBed
-    extends BlockLogic {
+    extends BlockLogic
+    implements ISupportable {
 
     public BlockLogicBed(final @NotNull Block<?> block) {
         super(block, Materials.WOOD);
@@ -39,27 +41,27 @@ public class BlockLogicBed
         int data = world.getBlockData(tilePos);
         final @NotNull TilePosc headPos;
         final @NotNull TilePosc footPos;
-        if (!IS_HEAD.bool(data)) {
-            final int dir = DIRECTION.get(data);
+        final var f2hDir = footToHeadMap[DIRECTION.get(data)].direction();
+        if (IS_HEAD.bool(data)) {
             headPos = tilePos;
-            footPos = tilePos.add(headBlockToFootBlockMap[dir].getDirection(), new TilePos());
+            footPos = tilePos.sub(f2hDir, new TilePos());
             if (world.getBlockType(footPos) != this.block) return true;
+            data = world.getBlockData(footPos);
         } else {
-            final int dir = DIRECTION.get(data);
             footPos = tilePos;
-            headPos = tilePos.sub(headBlockToFootBlockMap[dir].getDirection(), new TilePos());
+            headPos = tilePos.add(f2hDir, new TilePos());
             if (world.getBlockType(headPos) != this.block) return true;
         }
 
         // Explode in invalid dimensions
         if (!world.getWorldType().mayRespawn()) {
-            world.setBlockType(headPos, Blocks.AIR);
             assert world.getBlockType(footPos) == this.block; // made sure from above
+            world.setBlockType(headPos, Blocks.AIR);
             world.setBlockType(footPos, Blocks.AIR);
 
-            // prevents dupe... tho the dupe would need to be pretty funny to work
-            world.notifyBlockChange(headPos, Blocks.AIR); 
-            world.notifyBlockChange(footPos, Blocks.AIR); 
+            world.markBlockNeedsUpdate(headPos);
+            world.markBlockNeedsUpdate(footPos);
+            world.notifyBlocksInCapsuleOfNeighborChange(f2hDir, footPos, this.block);
 
             player.addStat(Achievements.SLEEP_NETHER, 1);
             world.createExplosion(null, tilePos.x() + 0.5F, tilePos.y() + 0.5F, tilePos.z() + 0.5F, 5F, true, false);
@@ -130,7 +132,7 @@ public class BlockLogicBed
     public static @Nullable TilePos otherHalf(final @NotNull World world, @NotNull TilePosc tilePos, int data) {
         final var isHead = IS_HEAD.bool(data);
         final var dir = DIRECTION.get(data);
-        final var direction = headBlockToFootBlockMap[DIRECTION.get(data)].getDirection();
+        final var direction = footToHeadMap[DIRECTION.get(data)].direction();
         final var otherPos = (isHead)
             ? tilePos.sub(direction, new TilePos())
             : tilePos.add(direction, new TilePos());
@@ -157,9 +159,9 @@ public class BlockLogicBed
 
         for (int d = 0; d <= 1; d++) {
             final @NotNull TilePos minPos = new TilePos(
-                tilePos.x - headBlockToFootBlockMap[direction].getOffsetX() * d - 1,
+                tilePos.x - footToHeadMap[direction].offsetX() * d - 1,
                 tilePos.y,
-                tilePos.z - headBlockToFootBlockMap[direction].getOffsetZ() * d - 1
+                tilePos.z - footToHeadMap[direction].offsetZ() * d - 1
             );
             final @NotNull TilePos maxPos = minPos.add(2, 0, 2, new TilePos());
 
@@ -186,10 +188,15 @@ public class BlockLogicBed
         return null;
     }
 
-    public static final @NotNull Side @NotNull [] headBlockToFootBlockMap = {
+    public static final @NotNull Side @NotNull [] footToHeadMap = {
         Side.SOUTH,
         Side.WEST,
         Side.NORTH,
         Side.EAST
     };
+
+    @Override
+    public @NotNull ISupport getSupportConstraint(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
+        return FullSupport.INSTANCE;
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBoneShale.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBoneShale.java
index 761c1bcd3..deba70176 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBoneShale.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBoneShale.java
@@ -20,7 +20,7 @@ public class BlockLogicBoneShale
         final @NotNull Direction direction = BlockLogicFullyRotatable.metaToDirection(data);
 
         float blockHardness = this.block.getHardness();
-        if (side != direction.getSide()) {
+        if (side != direction.side()) {
             blockHardness *= 66.6f;
         }
 
